unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, CheckLst, TAGraph,
  TASeries, TAChartAxis, TATransformations, ColoredCheckListBoxes;

type
  TCheckListBox = class(TColoredCheckListBox);

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    CheckListBox1: TCheckListBox;
    procedure CheckListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure CreateAxisForSeries(ALineSeries: TLineSeries);
    function CreateLineSeries(AColor: TColor): TLineSeries;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  LColor: TColor;
  LLineSeries: TLineSeries;
begin
//  Randomize;
  for i := 1 to Random(9) + 2 do
  begin
    case i of
      1:  LColor := clBlack;
      2:  LColor := clRed;
      3:  LColor := clLime;
      4:  LColor := clBlue;
      5:  LColor := clMaroon;
      6:  LColor := clGreen;
      7:  LColor := clNavy;
      8:  LColor := clPurple;
      9:  LColor := clOlive;
      10: LColor := clTeal;
    end;
    LLineSeries := CreateLineSeries(LColor);
    CheckListBox1.AddItem('Line' + IntToStr(i), LColor);
    CheckListBox1.Checked[i - 1] := True;
    CreateAxisForSeries(LLineSeries)
  end;
end;

procedure TForm1.CreateAxisForSeries(ALineSeries: TLineSeries);
var
  LAxis: TChartAxis;
  LAxisTransformation: TChartAxisTransformations;
  LAxisTransform: TAutoScaleAxisTransform;
begin
  LAxisTransformation := TChartAxisTransformations.Create(Self);
  LAxisTransform := TAutoScaleAxisTransform.Create(Self);
  LAxisTransform.Transformations := LAxisTransformation;
  LAxisTransform.MinValue := 0;
  LAxisTransform.MaxValue := 100;
  LAxis := Chart1.AxisList.Add;
  LAxis.Transformations := LAxisTransformation;
  LAxis.Visible := False;
  LAxis.Range.Max := ALineSeries.MaxYValue;
  LAxis.Range.Min := 0;
  LAxis.Range.UseMax := True;
  LAxis.Range.UseMin := True;
  ALineSeries.AxisIndexY := Chart1.AxisList.Count - 1;
end;

procedure TForm1.CheckListBox1Click(Sender: TObject);
begin
  Chart1.Series[CheckListBox1.ItemIndex].Active := CheckListBox1.Checked[CheckListBox1.ItemIndex];
end;

function TForm1.CreateLineSeries(AColor: TColor): TLineSeries;
const
  RandomRange: array[0..4] of Integer = (10, 100, 1000, 10000, 100000);
var
  i, LRange: Integer;
begin
  Result := TLineSeries.Create(Self);
  Result.SeriesColor := AColor;
  Chart1.AddSeries(Result);
  LRange := RandomRange[Random(5)];
  Result.AddXY(0, Random(LRange * 10));
  for i := 1 to 100 do
    Result.AddXY(i, Result.GetYValue(i - 1) + LRange div 2 - Random(LRange));
end;

end.

